"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isDate2 = _interopRequireDefault(require("lodash/isDate"));

var _attribute = _interopRequireDefault(require("./../attribute"));

var _dateAttributeValue = _interopRequireDefault(require("./dateAttributeValue"));

class DateAttribute extends _attribute.default {
  async validateType(value) {
    !(0, _isDate2.default)(value) && this.expected("Date object", typeof value);
  }

  setValue(value) {
    if (typeof value === "number" || typeof value === "string") {
      this.value.setCurrent(new Date(value));
    } else {
      this.value.setCurrent(value);
    }
  }
  /**
   * Returns AttributeValue class to be used on construct.
   * @returns {AttributeValue}
   */


  getAttributeValueClass() {
    return _dateAttributeValue.default;
  }

}

var _default = DateAttribute;
exports.default = _default;
//# sourceMappingURL=dateAttribute.js.map