"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _isPlainObject2 = _interopRequireDefault(require("lodash/isPlainObject"));

var _attribute = _interopRequireDefault(require("./../attribute"));

var _objectAttributeValue = _interopRequireDefault(require("./objectAttributeValue"));

class ObjectAttribute extends _attribute.default {
  /**
   * If value is assigned (checked in the parent validate call), it must by an instance of object.
   */
  async validateType(value) {
    if (Array.isArray(value)) {
      return;
    }

    if ((0, _isPlainObject2.default)(value)) {
      return;
    }

    this.expected("object", typeof value);
  }
  /**
   * Returns AttributeValue class to be used on construct.
   * @returns {AttributeValue}
   */


  getAttributeValueClass() {
    return _objectAttributeValue.default;
  }

}

var _default = ObjectAttribute;
exports.default = _default;
//# sourceMappingURL=objectAttribute.js.map