"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

/**
 * Base AttributesContainer class, can be extended to implement new types of model attributes.
 */
class AttributesContainer {
  constructor(model) {
    /**
     * Parent parentModel - instance of Model class.
     */
    this.parentModel = model;
    /**
     * Name of current attribute
     */

    this.name = "";
  }

  attr(attribute) {
    this.name = attribute;
    return this;
  }

  getParentModel() {
    return this.parentModel;
  }

  custom(attribute) {
    const model = this.getParentModel();
    const args = Array.from(arguments);
    args.shift();
    model.setAttribute(this.name, new attribute(this.name, this, ...args));
    return model.getAttribute(this.name);
  }

}

var _default = AttributesContainer;
exports.default = _default;
//# sourceMappingURL=attributesContainer.js.map