"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _attributesContainer = _interopRequireDefault(require("./attributesContainer"));

var _attributes = require("./attributes");

/**
 * Contains basic attributes. If needed, this class can be extended to add additional attributes,
 * and then be set as a new attributes container as the default one.
 */
class DefaultAttributesContainer extends _attributesContainer.default {
  attr(attribute) {
    super.attr(attribute);
    return this;
  }

  array() {
    const model = this.getParentModel();
    model.setAttribute(this.name, new _attributes.ArrayAttribute(this.name, this));
    return model.getAttribute(this.name);
  }

  char() {
    const model = this.getParentModel();
    model.setAttribute(this.name, new _attributes.CharAttribute(this.name, this));
    return model.getAttribute(this.name);
  }

  boolean() {
    const model = this.getParentModel();
    model.setAttribute(this.name, new _attributes.BooleanAttribute(this.name, this));
    return model.getAttribute(this.name);
  }

  date() {
    const model = this.getParentModel();
    model.setAttribute(this.name, new _attributes.DateAttribute(this.name, this));
    return model.getAttribute(this.name);
  }

  integer() {
    const model = this.getParentModel();
    model.setAttribute(this.name, new _attributes.IntegerAttribute(this.name, this));
    return model.getAttribute(this.name);
  }

  float() {
    const model = this.getParentModel();
    model.setAttribute(this.name, new _attributes.FloatAttribute(this.name, this));
    return model.getAttribute(this.name);
  }

  model(model) {
    const parent = this.getParentModel();
    parent.setAttribute(this.name, new _attributes.ModelAttribute(this.name, this, model));
    return parent.getAttribute(this.name);
  }

  models(model, keyValue = false) {
    const parent = this.getParentModel();
    parent.setAttribute(this.name, new _attributes.ModelsAttribute(this.name, this, model, keyValue));
    return parent.getAttribute(this.name);
  }

  object() {
    const model = this.getParentModel();
    model.setAttribute(this.name, new _attributes.ObjectAttribute(this.name, this));
    return model.getAttribute(this.name);
  }

}

var _default = DefaultAttributesContainer;
exports.default = _default;
//# sourceMappingURL=defaultAttributesContainer.js.map